;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; File:         cpstak.sch
; Description:  continuation-passing version of TAK
; Author:       Will Clinger
; Created:      20-Aug-87
; Language:     Scheme
; Status:       Public Domain
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;; CPSTAK -- A continuation-passing version of the TAK benchmark.
;;; A good test of first class procedures and tail recursion.

(define (cpstak x y z)
  (let loop ((x x) (y y) (z z) (k (lambda (x) x)))
    (if (>= y x)
	(k z)
	(loop (- x 1)
	     y
	     z
	     (lambda (v1)
	       (loop (- y 1)
		    z
		    x
		    (lambda (v2)
		      (loop (- z 1)
			   x
			   y
			   (lambda (v3)
			     (loop v1 v2 v3 k))))))))))

;;; Plus lent :
(define (tak x y z k)
  (do ((x x (- x 1))
       (k k (lambda (v1)
		 (tak (- y 1)
		      z
		      x
		      (lambda (v2)
			(tak (- z 1)
			     x
			     y
			     (lambda (v3)
			       (tak v1 v2 v3 k))))))))
      ((>= y x)
       (k z))))
    

(define (cpstak1 x y z)
  (tak x y z (lambda (a) a)))

;;; call: (cpstak 18 12 6) or (cpstak 12 6 1)

;(run-benchmark "CPSTAK" (lambda () (cpstak 18 12 6))) ; 3560 (2200)
